import Vue from 'vue'
import Router from 'vue-router'
import { normalizeURL, decode } from 'ufo'
import { interopDefault } from './utils'
import scrollBehavior from './router.scrollBehavior.js'

const _75cab004 = () => interopDefault(import('../pages/about.vue' /* webpackChunkName: "pages/about" */))
const _e49812c0 = () => interopDefault(import('../pages/Admin.vue' /* webpackChunkName: "pages/Admin" */))
const _355d59ba = () => interopDefault(import('../pages/Authorize.vue' /* webpackChunkName: "pages/Authorize" */))
const _cfe511da = () => interopDefault(import('../pages/export.vue' /* webpackChunkName: "pages/export" */))
const _25ec45ba = () => interopDefault(import('../pages/Login.vue' /* webpackChunkName: "pages/Login" */))
const _3ed17e3c = () => interopDefault(import('../pages/Register.vue' /* webpackChunkName: "pages/Register" */))
const _613caf07 = () => interopDefault(import('../pages/search.vue' /* webpackChunkName: "pages/search" */))
const _5c6fba42 = () => interopDefault(import('../pages/settings.vue' /* webpackChunkName: "pages/settings" */))
const _01beec1a = () => interopDefault(import('../pages/embed/list.vue' /* webpackChunkName: "pages/embed/list" */))
const _365afa7a = () => interopDefault(import('../pages/index.vue' /* webpackChunkName: "pages/index" */))
const _20e870ec = () => interopDefault(import('../pages/add/_edit.vue' /* webpackChunkName: "pages/add/_edit" */))
const _ba39aede = () => interopDefault(import('../pages/announcement/_id.vue' /* webpackChunkName: "pages/announcement/_id" */))
const _bc8a08aa = () => interopDefault(import('../pages/collection/_collection.vue' /* webpackChunkName: "pages/collection/_collection" */))
const _5f36548c = () => interopDefault(import('../pages/embed/_event_id.vue' /* webpackChunkName: "pages/embed/_event_id" */))
const _4e8db986 = () => interopDefault(import('../pages/event/_slug.vue' /* webpackChunkName: "pages/event/_slug" */))
const _d6b87ba2 = () => interopDefault(import('../pages/place/_place.vue' /* webpackChunkName: "pages/place/_place" */))
const _010c4fd2 = () => interopDefault(import('../pages/recover/_code.vue' /* webpackChunkName: "pages/recover/_code" */))
const _3590f908 = () => interopDefault(import('../pages/setup/_db.vue' /* webpackChunkName: "pages/setup/_db" */))
const _53d54062 = () => interopDefault(import('../pages/tag/_tag.vue' /* webpackChunkName: "pages/tag/_tag" */))
const _b13540b0 = () => interopDefault(import('../pages/user_confirm/_code.vue' /* webpackChunkName: "pages/user_confirm/_code" */))

const emptyFn = () => {}

Vue.use(Router)

export const routerOptions = {
  mode: 'history',
  base: '/',
  linkActiveClass: 'nuxt-link-active',
  linkExactActiveClass: 'nuxt-link-exact-active',
  scrollBehavior,

  routes: [{
    path: "/about",
    component: _75cab004,
    name: "about"
  }, {
    path: "/Admin",
    component: _e49812c0,
    name: "Admin"
  }, {
    path: "/Authorize",
    component: _355d59ba,
    name: "Authorize"
  }, {
    path: "/export",
    component: _cfe511da,
    name: "export"
  }, {
    path: "/Login",
    component: _25ec45ba,
    name: "Login"
  }, {
    path: "/Register",
    component: _3ed17e3c,
    name: "Register"
  }, {
    path: "/search",
    component: _613caf07,
    name: "search"
  }, {
    path: "/settings",
    component: _5c6fba42,
    name: "settings"
  }, {
    path: "/embed/list",
    component: _01beec1a,
    name: "embed-list"
  }, {
    path: "/",
    component: _365afa7a,
    name: "index"
  }, {
    path: "/add/:edit?",
    component: _20e870ec,
    name: "add-edit"
  }, {
    path: "/announcement/:id?",
    component: _ba39aede,
    name: "announcement-id"
  }, {
    path: "/collection/:collection?",
    component: _bc8a08aa,
    name: "collection-collection"
  }, {
    path: "/embed/:event_id?",
    component: _5f36548c,
    name: "embed-event_id"
  }, {
    path: "/event/:slug?",
    component: _4e8db986,
    name: "event-slug"
  }, {
    path: "/place/:place?",
    component: _d6b87ba2,
    name: "place-place"
  }, {
    path: "/recover/:code?",
    component: _010c4fd2,
    name: "recover-code"
  }, {
    path: "/setup/:db?",
    component: _3590f908,
    name: "setup-db"
  }, {
    path: "/tag/:tag?",
    component: _53d54062,
    name: "tag-tag"
  }, {
    path: "/user_confirm/:code?",
    component: _b13540b0,
    name: "user_confirm-code"
  }],

  fallback: false
}

export function createRouter (ssrContext, config) {
  const base = (config._app && config._app.basePath) || routerOptions.base
  const router = new Router({ ...routerOptions, base  })

  // TODO: remove in Nuxt 3
  const originalPush = router.push
  router.push = function push (location, onComplete = emptyFn, onAbort) {
    return originalPush.call(this, location, onComplete, onAbort)
  }

  const resolve = router.resolve.bind(router)
  router.resolve = (to, current, append) => {
    if (typeof to === 'string') {
      to = normalizeURL(to)
    }
    return resolve(to, current, append)
  }

  return router
}
